﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Microsoft.Azure.Documents;
using Microsoft.Azure.Documents.Client;
using Microsoft.Azure.Documents.Linq;
using Newtonsoft.Json;

namespace MiniSprint
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        public MainWindow()
        {
            InitializeComponent();
            GetAllBooks();
        }

        private const string EndpointUrl = "https://testnosql.documents.azure.com:443/";

        private const string AuthorizationKey =
            "1rtNVCsC9Gi/N3i3DVdOZthLrm9XLRZQ09V+0Fzyu4+UAiaaRuS2eVvt4ZWx/pTqpQzqW1KZyeHihEEHFGaOnw==";

        public static List<Book> bookList = new List<Book>();
        public List<Book> searchList = new List<Book>(); 

        private static async Task GetStartedDemo(string title, string author, int shelf, int row)
        {
            // Create a new instance of the DocumentClient
            var client = new DocumentClient(new Uri(EndpointUrl), AuthorizationKey);

            // Check to verify a database with the id=FamilyRegistry does not exist
            Database database =
                client.CreateDatabaseQuery().Where(db => db.Id == "LibaryRegistry").AsEnumerable().FirstOrDefault();

            // If the database does not exist, create a new database
            if (database == null)
            {
                database = await client.CreateDatabaseAsync(
                    new Database
                    {
                        Id = "LibaryRegistry"
                    });


            }

            // Check to verify a document collection with the id=FamilyCollection does not exist
            DocumentCollection documentCollection =
                client.CreateDocumentCollectionQuery("dbs/" + database.Id)
                    .Where(c => c.Id == "BookCollection")
                    .AsEnumerable()
                    .FirstOrDefault();

            // If the document collection does not exist, create a new collection
            if (documentCollection == null)
            {
                documentCollection = await client.CreateDocumentCollectionAsync("dbs/" + database.Id,
                    new DocumentCollection
                    {
                        Id = "BookCollection"
                    });


            }
            // Check to verify a document with the id=AndersenFamily does not exist
            Document document =
                client.CreateDocumentQuery("dbs/" + database.Id + "/colls/" + documentCollection.Id)
                    .Where(d => d.Id == title + author)
                    .AsEnumerable()
                    .FirstOrDefault();

            if (document == null)
            {
                // Create the Andersen Family document
                Book newBook = new Book
                {
                    Id = title + author,
                    Title = title,
                    Author = author,
                    Shelf = shelf,
                    Row = row
                };

                // id based routing for the first argument, "dbs/FamilyRegistry/colls/FamilyCollection"
                await client.CreateDocumentAsync("dbs/" + database.Id + "/colls/" + documentCollection.Id, newBook);
            }



        }

        public static void GetAllBooks()
        {
            // Create a new instance of the DocumentClient
            var client = new DocumentClient(new Uri(EndpointUrl), AuthorizationKey);

            // Check to verify a database with the id=FamilyRegistry does not exist
            Database database =
                client.CreateDatabaseQuery().Where(db => db.Id == "LibaryRegistry").AsEnumerable().FirstOrDefault();

            DocumentCollection documentCollection =
                client.CreateDocumentCollectionQuery("dbs/" + database.Id)
                    .Where(c => c.Id == "BookCollection")
                    .AsEnumerable()
                    .FirstOrDefault();

            var books = client.CreateDocumentQuery("dbs/" + database.Id + "/colls/" + documentCollection.Id,
                "SELECT * " +
                "FROM books b ");



            foreach (Book book in books)
            {

                bookList.Add(book);

            }
        }

        private void searchButton_Click(object sender, RoutedEventArgs e)
        {
            searchBocxList.Clear();
            var search = searchBox.Text;
            foreach (var book in bookList)
            {
                if (book.Title == search)
                {
                    searchList.Add(book);
                }
            }
            
            foreach (var book in searchList)
            {
                searchBocxList.Text += book;
            }
        }

        private async void addButton_Click(object sender, RoutedEventArgs e)
        {
            await GetStartedDemo(titleBox.Text, authorBox.Text, int.Parse(shelfBox.Text), int.Parse(rowBox.Text));
            GetAllBooks();
        }
    }
}
